#!/usr/bin/perl -w
use strict;
use WIN32::API;

#prototype
my $ips_connect=new Win32::API('trixi','long Connect (LPSTR * server,int port)');
my $ips_disconnect=new Win32::API('trixi','long Disconnect()');
my $ips_isonline=new Win32::API('trixi','long IsOnline()');
my $ips_readinteger=new Win32::API('trixi','long ReadInteger (long id)');
my $ips_readfloat=new Win32::API('trixi','double ReadFloat(long id)');
my $ips_readstring=new Win32::API('trixi','LPSTR ReadString(long id)');
my $ips_readboolean=new Win32::API('trixi','long ReadBoolean (long id)');
my $ips_runscript=new Win32::API('trixi','long RunScript (long id)');
my $ips_writestring=new Win32::API('trixi','long WriteString(long id, LPSTR v)');
my $ips_writeinteger=new Win32::API('trixi','long WriteInteger(long id, long v)');
my $ips_writefloat=new Win32::API('trixi','long WriteFloat(long id, double v)');
my $ips_writeboolean=new Win32::API('trixi','long WriteBoolean(long id, long v)');
#//---pro
my $ips_getscriptidbyname=new Win32::API('trixi','long GetScriptIDByName(LPSTR scriptname, long parent)');
my $ips_getvariableidbyname=new Win32::API('trixi','long GetVariableIDByName(LPSTR varname, long parent)');
my $ips_writedebugfile=new Win32::API('trixi','WriteDebugFile','PN','V');
my $ips_scriptexists=new Win32::API('trixi','long ScriptExists(long s)');
my $ips_variableexists=new Win32::API('trixi','long VariableExists(long v)');
#//--Callback
my $ips_setupdatecallback=new Win32::API('trixi','SetVarUpdateCallback','N','V');
my $ips_setchangecallback=new Win32::API('trixi','SetVarChangeCallback','N','V');
my $ips_setsimplecallback=new Win32::API('trixi','SetSimpleVarCallback','N','V');


#DLL geladen?
unless ($ips_connect) {
    print "DLL Load Failed or Function not found\n";
    exit 1;
}
print "DLL Loaded\n";
#log
$ips_writedebugfile->Call('Trixi.log',1);

#Connect (ret 0/1)
my $server='localhost';
my $port=3773;
my $r=$ips_connect->Call($server,$port);
unless ($r) {
    print "Connect failed\n";
    exit 1;
}
print "Connect OK\n";

#isOnline (ret 0/1)
$r=$ips_isonline->Call();
unless ($r) {
    print "IPS not Online\n";
    exit 1;
}
print "IPS ist Online\n";
my $parent=17655;
my $id;
my $val;
#read Boolean (ret 0/1)
$id=$ips_getvariableidbyname->Call('BoolVar',$parent);
if ($id) {
    $val=1;
    $r=$ips_writeboolean->Call($id,$val);
    $r=$ips_readboolean->Call($id);
    print "Return Bool: $r \n";
}
#read integer
#$id=$ips_getvariableidbyname->Call('IntegerVar',$parent);
$id=32522;
if ($id) {
    $val=2010;
    $r=$ips_writeinteger->Call($id,$val);
    $r=$ips_readinteger->Call($id);
    print "Return Integer: $r \n";
}

#read string
#$id=$ips_getvariableidbyname->Call('StringVar',$parent);
$id=14284;
if ($id) {
    $val='HalloTrixi';
    $r=$ips_writestring->Call($id,$val);
    $r=$ips_readstring->Call($id);
    print "Return String: $r \n";
}
#read float
#$id=$ips_getvariableidbyname->Call('FloatVar',$parent);
$id=44711;
if ($id) {
    $val=11.1;
    $r=$ips_writefloat->Call($id,$val);
    $r=$ips_readfloat->Call($id);
    print "Return Float: $r \n";
}
$id=$ips_getscriptidbyname->Call('TrixiDummy',$parent);
if ($id) {
    $r=$ips_runscript->Call($id);
}


$r=$ips_disconnect->Call();
unless ($r) {
    print "Disconnect failed\n";
    exit 1;
}
print "Disconnect OK\n";
